#include "item.h"
#include "player.h"
#include "extern.h"

item::item()
{
  myname = "New Item";
  myprice = 0;
  myuses = 0;
  for (int x = 0; x < 8; x++)
    mymodifiers[x] = 0;
}

item::item(const char *name, long int p, int uses, long int identifier, int m1, int m2, int m3, int m4, int m5, int m6, int m7, int m8)
{
  myname = name; // string = char*
  myprice = p;
  myuses = uses;
  mymodifiers[0] = m1;
  mymodifiers[1] = m2;
  mymodifiers[2] = m3;
  mymodifiers[3] = m4;
  mymodifiers[4] = m5;
  mymodifiers[5] = m6;
  mymodifiers[6] = m7;
  mymodifiers[7] = m8;
  id = identifier;
}

item::item(string name, long int p, int uses, long int identifier, int m1, int m2, int m3, int m4, int m5, int m6, int m7, int m8)
{
  myname = name; // string = char*
  myprice = p;
  myuses = uses;
  mymodifiers[0] = m1;
  mymodifiers[1] = m2;
  mymodifiers[2] = m3;
  mymodifiers[3] = m4;
  mymodifiers[4] = m5;
  mymodifiers[5] = m6;
  mymodifiers[6] = m7;
  mymodifiers[7] = m8;
  id = identifier;
}

item::~item()
{
  for (int x = 0; x < 8; x++)
    {
      mymodifiers[x] = 0;
    }

  myuses = 0;
  myname = "";
  myprice = 0;
}

void item::setType(type t)
{
  mytype = t;
}

bool item::operator<(const item &right) const
{
  return id < right.id;
}

bool item::operator>(const item &right) const
{
  return id > right.id;
}

bool item::operator==(const item &right) const
{
  return id == right.id;
}

bool item::operator!=(const item &right) const
{
  return id != right.id;
}

item &item::operator=(const item &right)
{
  myname = right.myname;
  myprice = right.myprice;
  myuses = right.myuses;
  id = right.id;
  mytype = right.mytype;

  for (int x = 0; x < 8; x++)
    {
      mymodifiers[x] = right.mymodifiers[x];
    }
  return *this; // enables cascading x=y=z;
}
weapon::~weapon()
{
}

bool weapon::setData(char *datastr)
{
  try
    {
      char *temp;
      temp = strtok(datastr, "~"); // Type

      mytype = WEAPON;
      // Grab the item's id
      temp = strtok(NULL, "~");
      id = stringtoint(temp);
      
      // Grab the item's name
      temp = strtok(NULL, "~");
      myname = temp;
      
      // Grab the item's price
      temp = strtok(NULL, "~");
      myprice = stringtoint(temp);
      
      // Grab the item's uses
      temp = strtok(NULL, "~");
      myuses = stringtoint(temp);
      
      // Grab the item's modifiers
      for (int x = 0; x < 4; x++)
	{
	  temp = strtok(NULL, "~");
	  mymodifiers[x] = stringtoint(temp);
	}
      // If we got here, we're successful
      return true;
    }
  catch (char *str)
    {
      log("Exception setting weapon data: %s", str);
      return false;
    }
}

bool weapon::use(Player *p)
{
  //  weapon(char *name, int p=0, int uses = -1, int strength=0, int defense=0, int maxhp=0)
  if (myuses == 0)
    return false;
  else
    {
      if (p->getWeapon())
	{
	  p->getWeapon()->undo(p);
	}
      p->strength += mymodifiers[0];
      p->defense += mymodifiers[1];
      p->maxhp += mymodifiers[2];
      p->setWeapon(*this);
    }

  return true;
}

void weapon::undo(Player *p)
{
  p->strength -= mymodifiers[0];
  p->defense -= mymodifiers[1];
  p->maxhp -= mymodifiers[2];
}

armor::~armor()
{
}

void armor::undo(Player *p)
{
  p->strength -= mymodifiers[0];
  p->defense -= mymodifiers[1];
  p->maxhp -= mymodifiers[2];
}

bool armor::setData(char *datastr)
{
  try
    {
      char *temp;
      strtok(datastr, "~"); // Type

      mytype = ARMOR;

      // Grab the item's id
      temp = strtok(NULL, "~");
      id = stringtoint(temp);

      // Grab the item's name
      temp = strtok(NULL, "~");
      myname = temp;
      
      // Grab the item's price
      temp = strtok(NULL, "~");
      myprice = stringtoint(temp);
      
      // Grab the item's uses
      temp = strtok(NULL, "~");
      myuses = stringtoint(temp);
      
      // Grab the item's modifiers
      for (int x = 0; x < 4; x++)
	{
	  temp = strtok(NULL, "~");
	  mymodifiers[x] = stringtoint(temp);
	}
      // If we got here, we were successful
      return true;
    }
  catch(char *str)
    {
      log("Exception setting armor data: %s", str);
      return false;
    }

}

bool armor::use(Player *p)
{
  //  weapon(char *name, int p=0, int uses = -1, int strength=0, int defense=0, int maxhp=0)
  if (myuses == 0)
    return false;
  else
    {
      if (p->getArmor())
	{
	  p->getArmor()->undo(p);
	}
      p->strength += mymodifiers[0];
      p->defense += mymodifiers[1];
      p->maxhp += mymodifiers[2];
      p->setArmor(*this);
    }

  return true;
}

potion::~potion()
{
}

bool potion::use(Player *p)
{
  // potion(char *name, int p=0, int uses = 1, int strength=0, int defense=0, int maxhp=0, int hp=0, int forest_fights=0, int player_fights=0, int gold=0, int bank=0)

  if (myuses == 0)
    return false;
  else
    {

      p->strength += myranges[0].random();
      if (p->strength > 32000 || p->strength < 0)
	{
	  p->strength = 32000;
	}
	  
      p->defense += myranges[1].random();
      if (p->defense > 32000 || p->defense < 0)
	{
	  p->defense = 32000;
	}

      p->maxhp += myranges[2].random();
      if (p->maxhp > 32000 || p->maxhp < 0)
	{
	  p->maxhp = 32000;
	}
      
      p->hp += myranges[3].random();
      if (p->hp > p->maxhp || p->hp < 0) // You can no longer go higher than your maxhp
	p->hp = p->maxhp;
      
      p->forest_fights += myranges[4].random();
      if (p->forest_fights > 32000 || p->forest_fights < 0)
	{
	  p->forest_fights = 32000;
	}

      p->player_fights += myranges[5].random();
      if (p->player_fights > 32000 || p->player_fights < 0)
	{
	  p->player_fights = 32000;
	}


      p->gold += myranges[6].random();
      if (p->gold > 2000000000 || p->gold < 0)
	{
	  p->gold = 2000000000;
	}

      p->bank += myranges[7].random();
      if (p->bank > 2000000000 || p->bank < 0)
	{
	  p->bank = 2000000000;
	}
    }
  return true;
}

void potion::undo(Player *p)
{
  return;
}

bool potion::setData(char *datastr)
{
  try
    {
      char *temp;

      temp = strtok(datastr, "~"); // Type

      mytype = POTION;
      
      // Grab the item's id
      temp = strtok(NULL, "~");
      id = stringtoint(temp);
      
      // Grab the item's name
      temp = strtok(NULL, "~");
      myname = temp;
      
      // Grab the item's price
      temp = strtok(NULL, "~");
      myprice = stringtoint(temp);
      
      // Grab the item's uses
      temp = strtok(NULL, "~");
      myuses = stringtoint(temp);
      
      // Grab the item's modifiers
      for (int x = 0; x < 8; x++)
	{
	  temp = strtok(NULL, "~");
	  myranges[x].low = stringtoint(temp);
	  temp = strtok(NULL, "~");
	  myranges[x].high = stringtoint(temp);
	}
    }
  catch(char *str)
    {
      log("Exception setting potion data: %s", str);
      return false;
    }
  // If we got here, we were successful
  return true;
}


itemContainer::itemContainer()
{
  myuses = 0;
  myitem = NULL;
}

itemContainer::itemContainer(item *i){
  myuses = i->uses();
  myitem = i;
}
itemContainer::itemContainer(const itemContainer &right)
{
  myuses = right.myuses;
  myitem = right.myitem;
}
itemContainer::~itemContainer()
{
  myuses = 0;
  myitem = NULL;
}

void itemContainer::use(Player *p)
{
  myitem->use(p);
  --myuses;
}

itemContainer &itemContainer::operator--()
{
  --myuses;
  return *this;
}

itemContainer itemContainer::operator--(int)
{
  itemContainer oldValue = *this;

  operator--();

  return oldValue;
}

itemContainer &itemContainer::operator++()
{
  ++myuses;

  return *this;
}

itemContainer itemContainer::operator++(int)
{
  itemContainer oldValue = *this;

  operator++();

  return oldValue;
}

void itemContainer::setItem(item *i)
{
  myitem = i;
}

bool itemContainer::operator<(const itemContainer &right) const
{
  return (*myitem < *right.myitem);
}

bool itemContainer::operator>(const itemContainer &right) const
{
  return (*myitem > *right.myitem);
}

bool itemContainer::operator==(const itemContainer &right) const
{
  return (*myitem == *right.myitem);
}

bool itemContainer::operator!=(const itemContainer &right) const
{
  return (*myitem != *right.myitem);
}

void itemContainer::setUses(int uses)
{
  myuses = uses;
}

tavernItem::tavernItem()
{
  myItem = NULL;
  myLevel = 1;
}

tavernItem::tavernItem(item *i, int l)
{
  setItem(i);
  setLevel(l);
}

void tavernItem::setItem(item *i)
{
  myItem = i;
}

void tavernItem::setLevel(int l)
{
  myLevel = l;
}

bool tavernItem::visible(Player *p)
{
  return (p != NULL && p->level >= myLevel);
}
